var bbScrollVid = [];

jQuery( document ).ready(function() {
    resetScrollVideos();
    jQuery( '.fl-builder-content' ).on( 'fl-builder.layout-rendered', resetScrollVideos );
    jQuery( '.fl-builder-content' ).on( 'fl-builder.preview-rendered', resetScrollVideos );

});

function setScrollVideoPosition(){

    bbScrollVid.forEach(function(vid){
        if(window.pageYOffset>= vid.startPoint && window.pageYOffset < vid.endPoint)
        vid.item[0].currentTime =  (window.pageYOffset-vid.startPoint) / (vid.height - windowHeight ) * vid.item[0].duration;
    });

    window.requestAnimationFrame(setScrollVideoPosition);
}

window.onresize = function(event) {
    refreshScrollVideoSizes();
};


function refreshScrollVideoSizes(){
    
    if(!jQuery('[scroll-video-url], [scroll-video]').length)
        return false;
    
    bbScrollVid.forEach(function(vid,index){
        bbScrollVid[index].height = vid.item.parents('.fl-row-bg-bb_scroll_video').height();
        bbScrollVid[index].startPoint = vid.item.parents('.fl-row-bg-bb_scroll_video').offset().top; 
        bbScrollVid[index].endPoint = vid.item.parents('.fl-row-bg-bb_scroll_video').height() + jQuery(vid.item).parents('.fl-row-bg-bb_scroll_video').offset().top;

    });

    windowHeight = jQuery(window).height();

    return true;
}


function resetScrollVideos(){

    bbScrollVid = [];

    jQuery('[scroll-video-url], [scroll-video]').each(function(){
        jQuery(this).find('.bb-scroll-video-container').remove(); // remove existing videos (BB preview modes)
    });

    jQuery('[scroll-video-url], [scroll-video]').each(function(){
        if(jQuery(this).attr('scroll-video') !== '')
            jQuery(this).find('.fl-row-content-wrap').prepend('<div class="bb-scroll-video-container"><video class="bb-scroll-video" muted="" playsinline=""><source src="'+jQuery(this).attr('scroll-video')+'" type="video/mp4"></video></div>');        
        else if(jQuery(this).attr('scroll-video-url') !== '')
            jQuery(this).find('.fl-row-content-wrap').prepend('<div class="bb-scroll-video-container"><video class="bb-scroll-video" muted="" playsinline=""><source src="'+jQuery(this).attr('scroll-video-url')+'" type="video/mp4"></video></div>');        

        jQuery(this).find('video').on("loadedmetadata", function() {
            vid = {
                item: jQuery(this),
                height: jQuery(this).parents('.fl-row-bg-bb_scroll_video').height(),
                startPoint: jQuery(this).parents('.fl-row-bg-bb_scroll_video').offset().top, 
                endPoint: jQuery(this).parents('.fl-row-bg-bb_scroll_video').height() + jQuery(this).parents('.fl-row-bg-bb_scroll_video').offset().top,
            }
            bbScrollVid.push(vid);
            window.requestAnimationFrame(setScrollVideoPosition);
        });
        return true;
    });
    refreshScrollVideoSizes();

}

