<?php

/**
 * Plugin Name: Beaver Builder Background Video Scroll Control
 * Plugin URI: https://sitespot.dev/
 * Description: Control the position of a video with scroll position in BB.
 * Version: 1.0.11
 * Author: Sitespot Dev
 * Author URI: https://sitespot.dev
 * License: GPL2
 */



if(! class_exists ( 'BB_Scroll_Video') && class_exists('FLBuilder'))
{
  class BB_Scroll_Video{

    function __construct(){

      //filters
      add_filter( 'fl_builder_register_settings_form' , array($this,'add_scroll_video_settings_to_builder'), 20 , 2 );
      add_filter( 'fl_builder_row_attributes' , array( $this,'add_row_attributes'), 10, 2);
      add_filter( 'wp_enqueue_scripts' , array($this,'bb_scroll_videos_column_scripts'), 20 , 2 );
	  
    }

	function add_scroll_video_settings_to_builder ($form, $slug ) {
		if ( 'row' === $slug) {
			$form['tabs']['style']['sections']['background']['fields']['bg_type']['options']['bb_scroll_video'] = __('Scroll Video', 'ssdev');
			$form['tabs']['style']['sections']['background']['fields']['bg_type']['toggle']['bb_scroll_video'] = array(
				'sections'  => array('bb_scroll_video')
				);
				
			$form['tabs']['style']['sections']['bb_scroll_video'] = array(
				'title'     => __('Background Video Scroller', 'btbb'),
				'fields'    => array(
					'mp4local' => array(
						'type'          => 'video',
						'label'         => __( 'Video Field', 'btbb' )
					),
					'mp4url' => array(
						'type'          => 'text',
						'label'         => __( 'Video Link', 'btbb' )
					),
					'bbScrollVideoFit' => array(
						'type'          => 'select',
						'label'         => __( 'Video Fit', 'btbb' ),
						'default'       => 'cover',
						'options'       => array(
							'cover'      => __( 'Cover', 'fl-builder' ),
							'contain'      => __( 'Contain', 'fl-builder' )
					),
				)
			));

		}
			return $form;
	}


    function add_row_attributes( $attrs, $row ) {
      if ( (!empty( $row->settings->mp4url)) || (!empty( $row->settings->mp4local)) ) {

        $attrs[ 'scroll-video' ] = wp_get_attachment_url($row->settings->mp4local);
        $attrs[ 'scroll-video-url' ] = $row->settings->mp4url;
        $attrs[ 'bb-scroll-video-fit' ] = $row->settings->bbScrollVideoFit;
      }

      return $attrs;
    }

    function bb_scroll_videos_column_scripts() {
        wp_enqueue_script( 'bb_scroll_video', plugin_dir_url( __FILE__ ) . 'bb-scroll-video.js', array('jquery') );
        wp_enqueue_style( 'scroll_bb_scroll_videovideo', plugin_dir_url( __FILE__ ) . 'bb-scroll-video.css' );
    }
  }
  
  $btsc = new BB_Scroll_Video();
}

// fin